/** 
 * @file ad7785.c
 */

#include "ad7785.h"

void ad7785_spi_reset(void)
{
    uint8_t spi_command[4] = {0};
    uint8_t spi_response[4] = {0};
    static bool success = false;

    //Send read command to COMMS reg
    memset(spi_command, 0xff, sizeof(spi_command));

    success = Spi_Transfer(spi_command, spi_response, 4, 4);
}

bool ad7785_id_check(void)
{
    uint8_t spi_command[2] = {0};
    uint8_t spi_response[2] = {0};
    static bool success = false;

    //Send read command to COMMS reg
    memset(spi_command, 0x00, sizeof(spi_command));
    memset(spi_response, 0x00, sizeof(spi_command));
    spi_command[0] = (AFE_READ_BITS << 6) |
                     (AFE_STATUS_REG_BITS << 3) |
                     (AFE_CR1_CR0_BITS);
    success = Spi_Transfer(spi_command, spi_response, 2, 2);

    spi_response[1] = (spi_response[1] & 0x0F);

    if(spi_response[1] == AD7785_ID)
    {
        return false;
    }else{
        return true;
    }
}

bool Ad7785_Init(void)
{
    bool config_error = false;
    
    ad7785_spi_reset();

    config_error |= ad7785_id_check();

    return config_error;
}